package com.example.jf_flutter_first_plugin;

import android.app.Activity;
import android.app.Application;
import android.widget.Toast;
import java.lang.ref.WeakReference;
import io.flutter.embedding.engine.plugins.FlutterPlugin;
import io.flutter.embedding.engine.plugins.activity.ActivityAware;
import io.flutter.embedding.engine.plugins.activity.ActivityPluginBinding;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;
import io.flutter.plugin.common.PluginRegistry.Registrar;

/** JfFlutterFirstPlugin */
public class JfFlutterFirstPlugin implements FlutterPlugin, ActivityAware, MethodCallHandler {

  private static final String PLUGIN_NAME = "jf_flutter_first_plugin";

  private MethodChannel mMethodChannel;
  private Application mApplication;
  private WeakReference<Activity> mActivity;


  // This static function is optional and equivalent to onAttachedToEngine. It supports the old
  // pre-Flutter-1.12 Android projects. You are encouraged to continue supporting
  // plugin registration via this function while apps migrate to use the new Android APIs
  // post-flutter-1.12 via https://flutter.dev/go/android-project-migration.
  //
  // It is encouraged to share logic between onAttachedToEngine and registerWith to keep
  // them functionally equivalent. Only one of onAttachedToEngine or registerWith will be called
  // depending on the user's project. onAttachedToEngine or registerWith must both be defined
  // in the same class.\


  //此处是旧的插件加载注册方式
 /* public static void registerWith(Registrar registrar) {
    final MethodChannel channel = new MethodChannel(registrar.messenger(), PLUGIN_NAME);
    channel.setMethodCallHandler(new JfFlutterFirstPlugin().initPlugin(channel, registrar));
  }

  public JfFlutterFirstPlugin initPlugin(MethodChannel methodChannel, Registrar registrar) {
    mMethodChannel = methodChannel;
    mApplication = (Application) registrar.context().getApplicationContext();
    mActivity = new WeakReference<>(registrar.activity());
    return this;
  }*/

  @Override
  public void onMethodCall(MethodCall call, Result result) {
    if (call.method.equals("getPlatformVersion")) {
      result.success("Android " + android.os.Build.VERSION.RELEASE);
    }  else if (call.method.equals("showToast")) {
      // 弹出 Toast
      Toast.makeText(mApplication, "来自 Android 端的 Toast", Toast.LENGTH_SHORT).show();
    } else {
      result.notImplemented();
    }
  }

  //此处是新的插件加载注册方式
  @Override
  public void onAttachedToEngine(FlutterPluginBinding flutterPluginBinding) {
    mMethodChannel = new MethodChannel(flutterPluginBinding.getBinaryMessenger(), PLUGIN_NAME);
    mApplication = (Application) flutterPluginBinding.getApplicationContext();
    mMethodChannel.setMethodCallHandler(this);
  }

  @Override
  public void onDetachedFromEngine(FlutterPluginBinding binding) {
    mMethodChannel.setMethodCallHandler(null);
    mMethodChannel = null;
  }

  @Override
  public void onAttachedToActivity(ActivityPluginBinding binding) {
    mActivity = new WeakReference<>(binding.getActivity());
  }

  @Override
  public void onDetachedFromActivityForConfigChanges() {

  }

  @Override
  public void onReattachedToActivityForConfigChanges(ActivityPluginBinding binding) {

  }

  @Override
  public void onDetachedFromActivity() {
    mActivity = null;
  }

}
